//+------------------------------------------------------------------+
//|                                         Nusa_TMACen_MultiEnv.mq4 |
//|                                                     No_Risk@2014 |
//|                                    Modified from TMAcentered.mq4 |
//|                                              By mladen forex-tsd |
//+------------------------------------------------------------------+
#property copyright "TMAcentered by mladen"
#property link      "www.forex-tsd.com"
#property description "Nusa_TMA Centered + Multi Envelope"
#property description "By No_risk@2014"

#property indicator_chart_window
#property indicator_buffers 7

//
//
//
//
//
//---- eksternal input
extern	string	Readme1	      = "--== TMAPeriod Input ==--",
						Readme2	      = "5M 15M 30M 1H 2H 3H 4H 6H 8H 12H 20H 1D",
						Readme3	      = "2D 3D 4D 1W 2W 3W 1MH 2MH 3MH 4MH 6MH 1Y",
						TMAPeriod       = "1D";
						
extern	string   Readme4        = "--== Applied_Price ==--",
						Readme5        = "0=Close 1=Open 2=High 3=Low",
						Readme6        = "4=Median(HL/2) 5=Typical(HLC/3) 6=Weighted(HLCC/4)";

extern int        Applied_Price  = 6;

extern double		EnvDeviation1  = 0.25;
						
extern bool       ShowPrice      = true,
                  ShowExtraEnv   = false;

extern double		EnvDeviation2  = 0.35,
                  EnvDeviation3  = 0.50;
                  

extern color      Midcolor       = DodgerBlue,
                  UpperEnvcolor1 = Red,
                  LowerEnvcolor1 = LimeGreen;

extern	string   Readme7        = "--== For ExtraEnv Color ==--";

extern color      UpperEnvcolor2 = Red,
                  UpperEnvcolor3 = Red,
                  LowerEnvcolor2 = LimeGreen,
                  LowerEnvcolor3 = LimeGreen;

double UpEnv1[];
double MidBuf[];
double LoEnv1[];
double UpEnv2[];
double UpEnv3[];
double LoEnv2[];
double LoEnv3[];
int HalfLength, Per;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   if(TMAPeriod == "1Y")			{ Per = 345600/Period(); }
	else if(TMAPeriod == "6MH")	{ Per = 172800/Period(); }
	else if(TMAPeriod == "4MH")	{ Per = 115200/Period(); }
	else if(TMAPeriod == "3MH")	{ Per = 86400/Period(); }
	else if(TMAPeriod == "2MH")	{ Per = 57600/Period(); }
	else if(TMAPeriod == "1MH")	{ Per = 28800/Period(); }
	else if(TMAPeriod == "3W")	   { Per = 21600/Period(); }
	else if(TMAPeriod == "2W")	   { Per = 14400/Period(); }
	else if(TMAPeriod == "1W")	   { Per = 7200/Period(); }
	else if(TMAPeriod == "4D")	   { Per = 5760/Period(); }
	else if(TMAPeriod == "3D")	   { Per = 4320/Period(); }
	else if(TMAPeriod == "2D")	   { Per = 2880/Period(); }
	else if(TMAPeriod == "1D")	   { Per = 1440/Period(); }
	else if(TMAPeriod == "20H")	{ Per = 1200/Period(); }
	else if(TMAPeriod == "12H")	{ Per = 720/Period(); }
	else if(TMAPeriod == "8H")	   { Per = 480/Period(); }
	else if(TMAPeriod == "6H")	   { Per = 360/Period(); }
	else if(TMAPeriod == "4H")	   { Per = 240/Period(); }
	else if(TMAPeriod == "3H")	   { Per = 180/Period(); }
	else if(TMAPeriod == "2H")	   { Per = 120/Period(); }
	else if(TMAPeriod == "1H")	   { Per = 60/Period(); }
	else if(TMAPeriod == "30M")	{ Per = 30/Period(); }
	else if(TMAPeriod == "15M")	{ Per = 15/Period(); }
	else if(TMAPeriod == "5M")	   { Per = 5/Period(); }
   
      
   HalfLength = Per/2;
   HalfLength=MathMax(HalfLength,1);

//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,STYLE_DASHDOTDOT,1,UpperEnvcolor1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,Midcolor);
   SetIndexStyle(2,DRAW_LINE,STYLE_DASHDOTDOT,1,LowerEnvcolor1);
   SetIndexStyle(3,DRAW_LINE,STYLE_DASHDOTDOT,1,UpperEnvcolor2);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1,UpperEnvcolor3);
   SetIndexStyle(5,DRAW_LINE,STYLE_DASHDOTDOT,1,LowerEnvcolor2);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1,LowerEnvcolor3);

//---- indicator short name
   IndicatorShortName("Nusa_TMACen_Env_("+TMAPeriod+")");
   
   SetIndexLabel(0,"Nusa_UpEnv1_("+EnvDeviation1+")_("+TMAPeriod+")");
   SetIndexLabel(1,"Nusa_MidEnv_("+TMAPeriod+")");
   SetIndexLabel(2,"Nusa_LoEnv1_("+EnvDeviation1+")_("+TMAPeriod+")");
   SetIndexLabel(3,"Nusa_UpEnv2_("+EnvDeviation2+")_("+TMAPeriod+")");
   SetIndexLabel(4,"Nusa_UpEnv3_("+EnvDeviation3+")_("+TMAPeriod+")");
   SetIndexLabel(5,"Nusa_LoEnv2_("+EnvDeviation2+")_("+TMAPeriod+")");
   SetIndexLabel(6,"Nusa_LoEnv3_("+EnvDeviation3+")_("+TMAPeriod+")");

   SetIndexBuffer(0,UpEnv1);  
   SetIndexBuffer(1,MidBuf); 
   SetIndexBuffer(2,LoEnv1); 
   SetIndexBuffer(3,UpEnv2); 
   SetIndexBuffer(4,UpEnv3); 
   SetIndexBuffer(5,LoEnv2); 
   SetIndexBuffer(6,LoEnv3); 

   SetIndexDrawBegin(0,HalfLength);
   SetIndexDrawBegin(1,HalfLength);
   SetIndexDrawBegin(2,HalfLength);
   SetIndexDrawBegin(3,HalfLength);
   SetIndexDrawBegin(4,HalfLength);
   SetIndexDrawBegin(4,HalfLength);
   SetIndexDrawBegin(6,HalfLength);

   return(0);
}
int deinit() 
{ 
   ObjectDelete("Price_UpEnv1_("+TMAPeriod+")");
   ObjectDelete("Price_MidEnv_("+TMAPeriod+")");
   ObjectDelete("Price_LoEnv1_("+TMAPeriod+")");
   ObjectDelete("Price_UpEnv2_("+TMAPeriod+")");
   ObjectDelete("Price_UpEnv3_("+TMAPeriod+")");
   ObjectDelete("Price_LoEnv2_("+TMAPeriod+")");
   ObjectDelete("Price_LoEnv3_("+TMAPeriod+")");

   return(0); 
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{

      int counted_bars=IndicatorCounted();
      int i,j,k,limit;

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
      limit=MathMin(Bars-counted_bars+HalfLength,Bars-1);

   //
   //
   //
   //
   //
      for (i=limit;i>=0;i--)
      {
         double sum  = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,Applied_Price,i);
         double sumw = (HalfLength+1);
         
         for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
         {
            sum  += k*iMA(NULL,0,1,0,MODE_SMA,Applied_Price,i+j);
            sumw += k;
            
            if (j<=i)
            {
               sum  += k*iMA(NULL,0,1,0,MODE_SMA,Applied_Price,i-j);
               sumw += k;
            }
         }
         
         MidBuf[i] = sum/sumw;
         UpEnv1[i] = (1+EnvDeviation1/100)*MidBuf[i];
         LoEnv1[i] = (1-EnvDeviation1/100)*MidBuf[i];
         
         if (ShowExtraEnv==true)
         {
         UpEnv2[i] = (1+EnvDeviation2/100)*MidBuf[i];
         UpEnv3[i] = (1+EnvDeviation3/100)*MidBuf[i];
         LoEnv2[i] = (1-EnvDeviation2/100)*MidBuf[i];
         LoEnv3[i] = (1-EnvDeviation3/100)*MidBuf[i];
         }
      }
   
   if (ShowPrice==true)
   {
   string Pricelabel1 = "Price_UpEnv1_("+TMAPeriod+")";
   ObjectCreate( Pricelabel1, OBJ_ARROW, 0, 0, 0 );
   ObjectSet( Pricelabel1, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet( Pricelabel1, OBJPROP_COLOR, UpperEnvcolor1);
   ObjectSet( Pricelabel1, OBJPROP_TIME1, Time[0]);
   ObjectSet( Pricelabel1, OBJPROP_PRICE1, UpEnv1[0]);
   
   string Pricelabel2 = "Price_MidEnv_("+TMAPeriod+")";
   ObjectCreate( Pricelabel2, OBJ_ARROW, 0, 0, 0 );
   ObjectSet( Pricelabel2, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet( Pricelabel2, OBJPROP_COLOR, Midcolor);
   ObjectSet( Pricelabel2, OBJPROP_TIME1, Time[0]);
   ObjectSet( Pricelabel2, OBJPROP_PRICE1, MidBuf[0]);

   string Pricelabel3 = "Price_LoEnv1_("+TMAPeriod+")";
   ObjectCreate( Pricelabel3, OBJ_ARROW, 0, 0, 0 );
   ObjectSet( Pricelabel3, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet( Pricelabel3, OBJPROP_COLOR, LowerEnvcolor1);
   ObjectSet( Pricelabel3, OBJPROP_TIME1, Time[0]);
   ObjectSet( Pricelabel3, OBJPROP_PRICE1, LoEnv1[0]);
   
      if (ShowExtraEnv==true)
      {
         string Pricelabel4 = "Price_UpEnv2_("+TMAPeriod+")";
         ObjectCreate( Pricelabel4, OBJ_ARROW, 0, 0, 0 );
         ObjectSet( Pricelabel4, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
         ObjectSet( Pricelabel4, OBJPROP_COLOR, UpperEnvcolor2);
         ObjectSet( Pricelabel4, OBJPROP_TIME1, Time[0]);
         ObjectSet( Pricelabel4, OBJPROP_PRICE1, UpEnv2[0]);
         
         string Pricelabel5 = "Price_UpEnv3_("+TMAPeriod+")";
         ObjectCreate( Pricelabel5, OBJ_ARROW, 0, 0, 0 );
         ObjectSet( Pricelabel5, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
         ObjectSet( Pricelabel5, OBJPROP_COLOR, UpperEnvcolor3);
         ObjectSet( Pricelabel5, OBJPROP_TIME1, Time[0]);
         ObjectSet( Pricelabel5, OBJPROP_PRICE1, UpEnv3[0]);

         string Pricelabel6 = "Price_LoEnv2_("+TMAPeriod+")";
         ObjectCreate( Pricelabel6, OBJ_ARROW, 0, 0, 0 );
         ObjectSet( Pricelabel6, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
         ObjectSet( Pricelabel6, OBJPROP_COLOR, LowerEnvcolor2);
         ObjectSet( Pricelabel6, OBJPROP_TIME1, Time[0]);
         ObjectSet( Pricelabel6, OBJPROP_PRICE1, LoEnv2[0]);


         string Pricelabel7 = "Price_LoEnv3_("+TMAPeriod+")";
         ObjectCreate( Pricelabel7, OBJ_ARROW, 0, 0, 0 );
         ObjectSet( Pricelabel7, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
         ObjectSet( Pricelabel7, OBJPROP_COLOR, LowerEnvcolor3);
         ObjectSet( Pricelabel7, OBJPROP_TIME1, Time[0]);
         ObjectSet( Pricelabel7, OBJPROP_PRICE1, LoEnv3[0]);
      }
   }

   return(0);
}